from rest_framework import serializers

from api.models import MigrationDetails, Migration, VContainer, LoadValue, Hypervisor


class ControllerSerializer(serializers.Serializer):
    """Controller Response Serializer. """
    name = serializers.CharField(help_text='The name of the OpenStack hosting Keystone in source DC', max_length=30)
    ip = serializers.CharField(help_text='The IP of the OpenStack Node', max_length=15)
    port = serializers.IntegerField(help_text='The Port of the DCMC Master', default=0)


class HypervisorSerializer(serializers.ModelSerializer):
    """Hypervisor Serializer Class."""

    class Meta:
        model = Hypervisor
        fields = ('host_ip', 'host_name', 'public_ssh_key', 'vpn_ip')


class LoadValueSerializer(serializers.ModelSerializer):
    """Load Value Model Serializer. """

    class Meta:
        model = LoadValue
        fields = ('parameter', 'value', 'uom')


class MigrationSerializer(serializers.ModelSerializer):
    """Migration Model Serializer. """

    class Meta:
        model = Migration
        fields = ('id', 'load', 'marketaction', 'status')


class MigrationDetailsSerializer(serializers.ModelSerializer):
    """Migration Details Model Serializer. """

    class Meta:
        model = MigrationDetails
        fields = ('id', 'marketaction', 'source', 'destination',
                  'delivery_start', 'delivery_end', 'transaction')


class MigrationRequestSerializer(serializers.Serializer):
    """Migration Request Serializer Class."""
    ACTION_TYPES = (
        ('bid', 'bid'),
        ('offer', 'offer')
    )

    date = serializers.DateTimeField(help_text='The time on which the request is created')
    vc_tag = serializers.CharField(help_text='The VC Tag, as this has been generated by the VCG', max_length=100)
    starttime = serializers.DateTimeField(help_text='The time on which the requested migration is planned to start')
    endtime = serializers.DateTimeField(help_text='The time on which the requested migration is planned to end')
    load_values = LoadValueSerializer(help_text='Information about the load characteristics', many=True)
    price = serializers.FloatField(help_text='The price suggested for the migration action')
    action_type = serializers.ChoiceField(help_text='The type of market action placed on the Catalyst ITLM',
                                          choices=ACTION_TYPES)


class MigrationUpdateSerializer(serializers.Serializer):
    """Migration Update Serializer Class."""
    MIGRATION_STATUSES = (
        ('pending', 'Migration is pending'),
        ('posted', 'Migration has been posted'),
        ('rejected', 'Migration was rejected'),
        ('started', 'Migration has started'),
        ('success', 'Migration succeeded'),
        ('failed', 'Migration has failed'),
    )

    migration = serializers.IntegerField(help_text='The ID of the migration')
    status = serializers.ChoiceField(help_text='The status of the migration', choices=MIGRATION_STATUSES)
    marketaction = serializers.IntegerField(help_text='The ID of the market action corresponding to the migration')


class ServiceEndpointSerializer(serializers.Serializer):
    """Service Endpoint Serializer Class."""
    authenticate_uri = serializers.CharField(help_text='OS Authenticate URI', max_length=256)
    authorization_url = serializers.CharField(help_text='OS Authorization URL', max_length=256)
    glance_service = serializers.CharField(help_text='OS Glance Service', max_length=256)
    memcached_service = serializers.CharField(help_text='OS Memcached Servers', max_length=256)
    memcached_secret_key = serializers.CharField(help_text='OS Memcached Secret Key', max_length=256)
    neutron_service = serializers.CharField(help_text='OS Neutron Service', max_length=256)
    neutron_password = serializers.CharField(help_text='OS Neutron Password', max_length=256)
    nova_password = serializers.CharField(help_text='OS Nova Password', max_length=256)
    placement_service = serializers.CharField(help_text='OS Placement Service', max_length=256)
    placement_password = serializers.CharField(help_text='OS Placement Password', max_length=256)
    transport_url = serializers.CharField(help_text='OS Transport URL', max_length=256)
    nfs_server_host = serializers.CharField(help_text='NFS Server Host', max_length=256)
    nfs_server_root = serializers.CharField(help_text='NFS Server Root Dir', max_length=256)
    nova_uid = serializers.CharField(help_text='Nova UID', max_length=8)
    nova_gid = serializers.CharField(help_text='Nova GID', max_length=8)
    libvirt_uid = serializers.CharField(help_text='Libvirt-Qemu UID', max_length=8)
    libvirt_gid = serializers.CharField(help_text='KVM GID', max_length=8)
    libvirt_group = serializers.CharField(help_text='Libvirt GID', max_length=8)
    libvirt_user = serializers.CharField(help_text='Libvirt User', max_length=8)


class VContainerSerializer(serializers.ModelSerializer):
    """VContainer Model Serializer. """

    class Meta:
        model = VContainer
        fields = ('id', 'cpu', 'cpu_uom', 'ram', 'ram_uom', 'disk', 'disk_uom',
                  'start', 'end', 'uuid', 'transaction', 'status', 'covpn_owner')
